VERSION 5.00
Begin VB.Form frmConnection 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Login"
   ClientHeight    =   2880
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   2880
   ScaleLeft       =   100
   ScaleMode       =   0  'User
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton btnSelectProject 
      Caption         =   "Select Project"
      Enabled         =   0   'False
      Height          =   285
      Left            =   1515
      TabIndex        =   9
      Top             =   2295
      Width           =   2265
   End
   Begin VB.ComboBox cbProjects 
      Enabled         =   0   'False
      Height          =   315
      Left            =   990
      Sorted          =   -1  'True
      TabIndex        =   4
      Top             =   1890
      Width           =   3615
   End
   Begin VB.ComboBox cbProjectList 
      Height          =   315
      Left            =   990
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   135
      Width           =   3615
   End
   Begin VB.CommandButton btnConnect 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   285
      Left            =   1485
      TabIndex        =   8
      Top             =   1440
      Width           =   2310
   End
   Begin VB.TextBox txtPWD 
      Height          =   330
      IMEMode         =   3  'DISABLE
      Left            =   990
      PasswordChar    =   "*"
      TabIndex        =   3
      Top             =   990
      Width           =   3570
   End
   Begin VB.TextBox txtUID 
      Height          =   330
      Left            =   990
      TabIndex        =   2
      Top             =   540
      Width           =   3570
   End
   Begin VB.Label Label3 
      Caption         =   "Password:"
      Height          =   240
      Left            =   90
      TabIndex        =   7
      Top             =   1035
      Width           =   810
   End
   Begin VB.Label Label2 
      Caption         =   "Login id:"
      Height          =   240
      Left            =   90
      TabIndex        =   6
      Top             =   630
      Width           =   690
   End
   Begin VB.Label Label1 
      Caption         =   "Projects:"
      Height          =   240
      Left            =   90
      TabIndex        =   5
      Top             =   1935
      Width           =   735
   End
   Begin VB.Label S 
      Caption         =   "Server:"
      Height          =   195
      Left            =   90
      TabIndex        =   0
      Top             =   180
      Width           =   735
   End
End
Attribute VB_Name = "frmConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'===============================================================================================
'This code is distributed "as is".
'No warranty of any kind is expressed or implied. You use it at your own risk.
'I disclaim all liabilities for consequential data loss, damages, loss of profits or any other
'kind of loss while using or misusing it.
'
'-----------------------------------------------------------------------------------------------
'Please ask for my approval at ssorin@gmail.com before distributing or posting
'this code to a site other than http://www.microstrategy101.com or http://microstrategyblog.com/
'===============================================================================================




Private Sub Form_Load()
    
    'Indicate a busy mouse icon...
    MousePointer = vbHourglass
    
    'getting the available datasources
    Set objProjectList = New DSSDataSourceEnumerator
    
    'load registry content
    objProjectList.LoadFromRegistry

    'add the project sources into the combo list
    If objProjectList.Count > 0 Then
        For i = 1 To objProjectList.Count
            'exclude the registry entry that looks like {...}
            'find more by going to regedit -> HKEY_LOCAL_MACHINE -> SOFTWARE -> MICROSTRATEGY -> DATA SOURCES
            If Not objProjectList.Item(i).Name Like "{*}" Then
                cbProjectList.AddItem (objProjectList.Item(i).Name)
            End If
        Next i
    End If
    
    'indicate a default mouse icon...
    MousePointer = vbDefault
    
    'highlight and select the first item in the combo list
    cbProjectList.Text = cbProjectList.List(0)
End Sub


Private Sub btnConnect_Click()

    
    On Error GoTo errHandler
    
    'Test if at least User was provided
    If Me.txtUID.Text = "" Then
        MsgBox "Please enter user name", vbCritical, "Error Connecting"
        Exit Sub
    End If
    
    'indicate a busy mouse icon...
    MousePointer = vbHourglass
    
    'get the project source name based on the combo list selection
    'using the string name is not enough, thus the objProjectList must be called
    For i = 1 To objProjectList.Count
        If Me.cbProjectList.Text = objProjectList.Item(i).Name Then
            DataSournceInd = i 'this is the index of the selected project
        End If
    Next i
    
    'provide connection information
    Set objServer = objProjectList.Item(DataSournceInd)
    objServer.AuthMode = DssAuthStandard
    objServer.login = Me.txtUID.Text
    objServer.Passwd = Me.txtPWD.Text

    'connect to Project Source
    objServer.Init
    
    
    'getting all projects
    If objServer.Enumerator.Count > 0 Then
        For i = 1 To objServer.Enumerator.Count
            cbProjects.AddItem objServer.Enumerator.Item(i).ProjectName
        Next i
    Else
        MsgBox strErr, vbCritical, "No projects found!"
    End If
    
    'highlight and select the first project in the combo list
    cbProjects.Text = cbProjects.List(0)
    
    'cosmetical stuff
    cbProjects.Enabled = True
    cbProjects.SetFocus
    btnSelectProject.Default = True
    btnSelectProject.Enabled = True

    'Indicate a default mouse icon...
    MousePointer = vbDefault
    
    
'display error information
errHandler: If Err.Description <> "" Then
                MsgBox Err.Description, , "Login error"
                'indicate a default mouse icon...
                MousePointer = vbDefault
            End If

End Sub


Private Sub btnSelectProject_Click()
    
    On Error GoTo errHandler
    
    
    'get the project name based on the combo list selection
    For i = 1 To objServer.Enumerator.Count
        If Me.cbProjects.Text = objServer.Enumerator.Item(i).ProjectName Then
            ServerInd = i
        End If
    Next i
    
    'provide connection information
    Set objDataSource = objServer.Enumerator.Item(ServerInd)
    objDataSource.AuthMode = DssAuthStandard
    objDataSource.login = Me.txtUID.Text
    objDataSource.Passwd = Me.txtPWD.Text
    
    'connect to project
    objDataSource.Init
    Set objSession = objDataSource.CreateSession
    
    
    'indicate a default mouse icon...
    MousePointer = vbDefault
    

'display error information
errHandler: If Err.Description <> "" Then
                MsgBox Err.Description, , "Login error"
                'indicate a default mouse icon...
                MousePointer = vbDefault
            End If
           
    'share the success with the user
    'this is where you can call the main form of your SDK application and unload frmConnection
    If Err.Description = "" Then
        
        'Enable the search field and buttons
        frmMain.txtNameID.Enabled = True
        frmMain.txtNameID.SetFocus
        frmMain.btnSearchByID1arg.Enabled = True
        frmMain.btnSearchByID2arg.Enabled = True
        frmMain.btnSearchByName.Enabled = True
        
        'Update the status bar text
        frmMain.StatusBar1.SimpleText = "Connected to " & objProjectList.Item(DataSournceInd).Name & " on " & objServer.Enumerator.Item(ServerInd).ProjectName
        
        'Call frmMain
        frmMain.Show
        
        'Unload this form
        Unload frmConnection
    End If


    
End Sub

Private Sub Form_Unload(Cancel As Integer)

'clean up
'when you call another form after connecting, you might want to cut/paste this code to that form
'otherwise you will disconnect whenever closing frmConnection

'Set objProjectList = Nothing
'Set objServer = Nothing
'Set objDataSource = Nothing
'Set objSession = Nothing

End Sub



